/* IMPORTANT: I don't know if it's necessary, but I put 10k resistors on
 * the  receive pin of the pic,  and it works fine.
 */

/*         		                 PIC16F84
 *                 	               .-----------.
 * 	              orange TRANSMIT -|RA2     RA1|- 
 *                     		      -|RA3     RA0|-  RECIEVE white
 *              		      -|RA4    OSC1|- XT CLOCK pin1, 27pF to GND
 *   		       PUSH BUTTON    -|MCLR   OSC2|- XT CLOCK pin2, 27pF to GND
 *          		  GND 	      -|Vss     Vdd|- +5v
 *            	                      -|RB0     RB7|- 
 *	       Transistor Motor PWM   -|RB1     RB6|- 
 *		                      -|RB2     RB5|- 
 *                		      -|RB3     RB4|- 
 *                		       '-----------'       
 *
 *  PUSH BUTTON = PIN - BUTTON - GND
 *                PIN - 10k - +5v  
 */

/*  rs232 interface (serial port communications) without a level converter.
 *  Therefore microcontroller pins are connected DIRECTLY to the serial cable.
 *  Therefore inverted (from standard) logic is used.
 *  
 *  PIC PIN17 PORTA0 - TRANSMIT (receive at PC end of serial cable) white
 *  PIC PIN01 PORTA2 - RECEIVE (transmit at PC end of serial cable) orange
 */

/*  looking head on at the female connector of a serial mouse coard:
 *  i.e. the end that plugs into your pc
 *
 *  5 4 3 2 1      =      blue    null    orange      white    null
 *   9 8 7 6       =          null    null      yellow     null
 *
 *  the following are loose wires on the other end of the coard.
 *  i.e. where it would have been soldered to the mouse circuit board.
 *
 *  5 = blue   = gnd = GND
 *  3 = orange = td  = PIC PIN17 PORTA0
 *  2 = white  = rd  = PIC PIN01 PORTA2
 *  7 = yellow = rts = unused
 */

#include <pic.h>
#include "rs232.c"

__CONFIG(WDTDIS & XT & UNPROTECT);



# define Motor_PIN RB1 


void PWM_STOP();
void PWM_LOW();
void PWM_MID();
void PWM_HIGH();

unsigned 	char c ;

int Duty = 0  , t = 0 , period = 2000 ;


main(void) 
{
  TRISA = 0b00000001;
  TRISB = 0b00000001;
  PORTA = 0;
  PORTB = 0;



  rs232_initialize();


  	rs232_send_string(" Hello Abohmeed");
	

		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 

		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 


	rs232_send_string(" Please enter Motor Speed : 0 STOP , 1 LOW , 2 MID , 3 HIGH ");



  for (;;) 
  {
  
	c = 0 ; 

 	if (RA0 == 1) 


	c = rs232_recv_char(); 



if ( c != 0 )

{

	rs232_send_char(c);

		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 


	if ( c == 48  )		  		PWM_STOP();	// 0 INPUT	

else	if ( c == 49  )		  		PWM_LOW();	// 1 INPUT	

else	if ( c == 50  )		  		PWM_MID();	// 2 INPUT	

else	if ( c == 51  )		 		PWM_HIGH();	// 3 INPUT	


else		


	{


		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 



		rs232_send_string(" WRONG OPTION ");
	}

}


 

	
	if( Duty !=0 )
	
 	{	
		t ++ ;

		if ( t >= Duty )		Motor_PIN = 0 ;


		if ( t >= period )		{	Motor_PIN = 1 ;  t = 0 ; }

	}

	else 

	Motor_PIN = 0 ;


  }
}









void PWM_STOP()

{ 
		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 
		rs232_send_char(CR); 			// CARRIGE RETURN 


		rs232_send_string(" MOTOR STOP ");


		Duty = 0 ;


}



void PWM_LOW()

{ 
		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 
		rs232_send_char(CR); 			// CARRIGE RETURN 


		rs232_send_string(" MOTOR LOW ");


		Duty = 200 ;

}


void PWM_MID()

{		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 
		rs232_send_char(CR); 			// CARRIGE RETURN 


		rs232_send_string(" MOTOR MID ");

		Duty = 1000 ;


}


void PWM_HIGH()

{		rs232_send_char(NL); 			// NEW LINE

		rs232_send_char(CR); 			// CARRIGE RETURN 
		rs232_send_char(CR); 			// CARRIGE RETURN 


		rs232_send_string(" MOTOR HIGH ");

		Duty = 2000 ;

}






